import java.awt.*;
import java.util.*;

//Boolean Space Partition tree
class BSPTree {
	private Square data = null; //this node's Square
	private BSPTree back = null; //Squares behind root
	private BSPTree front = null; //Squares in front of this one

	public BSPTree() {
	}	

	public BSPTree(Square s) {
		data = s;
	}
	
	//insert a Square into the BSPTree
	public void insert(Square s) {
		if (data == null) data = s; //if tree is empty
		else if (data.behind(s.center)) {
			//root Square is behind new Square--insert in front subtree
			if (front == null) front = new BSPTree(s);
			else front.insert(s);
		}
		else { //root Square is in front of new Square--insert in back subtree
			if (back == null) back = new BSPTree(s);
			else back.insert(s);
		}
	}
	
	//render Squares in back-to-front order with respect to viewpoint
	public void enumerate(Figure f, ThreeDPoint viewpoint) {
		if (data.behind(viewpoint)) { //view
			if (back != null) back.enumerate(f,viewpoint);
			f.render(data);
			if (front != null) front.enumerate(f,viewpoint);
		} else {
			if (front != null) front.enumerate(f,viewpoint);
			f.render(data);
			if (back != null) back.enumerate(f,viewpoint);
		}
	}
}